global function FloorIsLava_Init

struct {
    var OnGroundRui
    var OnWallRui
    var OnAirRui
    int OnGround = 0
    int OnWall = 0
    int OnAir = 0
} file

void function FloorIsLava_Init(){
    SetupFILRui()
    thread UpdateFIL()
}

void function SetupFILRui(){
    file.OnGroundRui = RuiCreate($"ui/cockpit_console_text_top_left.rpak", clGlobal.topoCockpitHudPermanent, RUI_DRAW_COCKPIT, 0)
    RuiSetInt(file.OnGroundRui, "maxLines", 1)
	RuiSetInt(file.OnGroundRui, "lineNum", 1)
	RuiSetFloat2(file.OnGroundRui, "msgPos", <0.9, 0.1, 0.0>)
	RuiSetFloat(file.OnGroundRui, "msgFontSize", 25.0)
	RuiSetFloat(file.OnGroundRui, "msgAlpha", 0.5)
	RuiSetFloat(file.OnGroundRui, "thicken", 0.0)
	RuiSetFloat3(file.OnGroundRui, "msgColor", <1.0, 1.0, 1.0>)
	RuiSetString(file.OnGroundRui, "msgText", "")

    file.OnWallRui = RuiCreate($"ui/cockpit_console_text_top_left.rpak", clGlobal.topoCockpitHudPermanent, RUI_DRAW_COCKPIT, 0)
    RuiSetInt(file.OnWallRui, "maxLines", 1)
	RuiSetInt(file.OnWallRui, "lineNum", 1)
	RuiSetFloat2(file.OnWallRui, "msgPos", <0.9, 0.125, 0>)
	RuiSetFloat(file.OnWallRui, "msgFontSize", 25.0)
	RuiSetFloat(file.OnWallRui, "msgAlpha", 0.5)
	RuiSetFloat(file.OnWallRui, "thicken", 0.0)
	RuiSetFloat3(file.OnWallRui, "msgColor", <1.0, 1.0, 1.0>)
	RuiSetString(file.OnWallRui, "msgText", "")

    file.OnAirRui = RuiCreate($"ui/cockpit_console_text_top_left.rpak", clGlobal.topoCockpitHudPermanent, RUI_DRAW_COCKPIT, 0)
    RuiSetInt(file.OnAirRui, "maxLines", 1)
	RuiSetInt(file.OnAirRui, "lineNum", 1)
	RuiSetFloat2(file.OnAirRui, "msgPos", <0.9, 0.15, 0>)
	RuiSetFloat(file.OnAirRui, "msgFontSize", 25.0)
	RuiSetFloat(file.OnAirRui, "msgAlpha", 0.5)
	RuiSetFloat(file.OnAirRui, "thicken", 0.0)
	RuiSetFloat3(file.OnAirRui, "msgColor", <1.0, 1.0, 1.0>)
	RuiSetString(file.OnAirRui, "msgText", "")
}

void function UpdateFIL(){
    while(true){
        UpdateAirTime()
        RuiSetString(file.OnGroundRui, "msgText", "Ground : " + (file.OnGround*100/TotalTime()).tostring() +"%")
        RuiSetString(file.OnWallRui, "msgText",   "Wall   : " + (file.OnWall*100/TotalTime()).tostring()+"%")
        RuiSetString(file.OnAirRui, "msgText",    "Air    : " + (file.OnAir*100/TotalTime()).tostring()+"%")
        wait 0
    }
}

void function UpdateAirTime(){
    entity p = GetLocalClientPlayer()
    if(!IsValid(p)) return
    if(!IsAlive(p)) return
    if(p.IsTitan()) return
    if(!p.IsPlayer()) return
    if(IsSpectating()) return

    if(p.IsWallRunning()){
        file.OnWall++
    }else if(!p.IsOnGround()){ //there should be some sort of check to see if player is in control
		file.OnAir++
	}
	else{
        file.OnGround++
    }
}

int function TotalTime(){
    if(file.OnGround+file.OnWall+file.OnAir == 0){
        return 1
    }
    return file.OnGround+file.OnWall+file.OnAir
}